*** Settings ***

Resource            ${CURDIR}${/}..${/}..${/}..${/}resources/import.resource

Test Timeout        120s
Test Setup          Ctn Generic Suite Setup

*** Variables ***
${CMD}      ${CENTREON_PLUGINS} --plugin=network::mikrotik::snmp::plugin


*** Test Cases ***
lteinterfaces ${tc}
    [Tags]    network    mikrotik    snmp
    ${command}    Catenate
    ...    ${CMD}
    ...    --mode=lte-interfaces
    ...    --hostname=${HOSTNAME}
    ...    --snmp-version=${SNMPVERSION}
    ...    --snmp-port=${SNMPPORT}
    ...    --snmp-community=network/mikrotik/snmp/mikrotik-chateau-lte6
    ...    --snmp-timeout=1
    ...    ${extra_options}
 
    # first run to build cache
    Run    ${command}
    # second run to control the output
    Ctn Run Command And Check Result As Strings    ${command}    ${expected_result}

    Examples:        tc     extra_options                                                 expected_result    --
            ...      1      ${EMPTY}                                                      OK: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      2      --add-status                                                  OK: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      3      --add-global                                                  OK: Total port : 1, AdminStatus Up : 1, AdminStatus Down : 0, OperStatus Up : 1, OperStatus Down : 0 - Interface 'lte1' [imei: 863359044096580] rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'total.interfaces.count'=1;;;0;1 'total.interfaces.admin.up.count'=1;;;0;1 'total.interfaces.admin.down.count'=0;;;0;1 'total.interfaces.operational.up.count'=1;;;0;1 'total.interfaces.operational.down.count'=0;;;0;1 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      4      --add-traffic                                                 OK: Interface 'lte1' [imei: 863359044096580] Traffic In : 0.00b/s (-), Traffic Out : 0.00b/s (-), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.traffic.in.bitspersecond'=0.00;;;0; 'lte1~863359044096580#interface.traffic.out.bitspersecond'=0.00;;;0; 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      5      --add-errors                                                  OK: Interface 'lte1' [imei: 863359044096580] Packets In Discard : 0.00% (0 on 0), Packets In Error : 0.00% (0 on 0), Packets Out Discard : 0.00% (0 on 0), Packets Out Error : 0.00% (0 on 0), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.packets.in.discard.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.error.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.discard.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.error.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      6      --add-cast                                                    OK: Interface 'lte1' [imei: 863359044096580] rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB, In Ucast : 0.00% (0 on 0), In Bcast : 0.00% (0 on 0), In Mcast : 0.00% (0 on 0), Out Ucast : 0.00% (0 on 0), Out Bcast : 0.00% (0 on 0), Out Mcast : 0.00% (0 on 0) | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0; 'lte1~863359044096580#interface.packets.in.unicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.broadcast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.multicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.unicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.broadcast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.multicast.percentage'=0.00%;;;0;100
            ...      7      --add-traffic --add-errors --add-cast --name='lte1'           OK: Interface 'lte1' [imei: 863359044096580] Traffic In : 0.00b/s (-), Traffic Out : 0.00b/s (-), Packets In Discard : 0.00% (0 on 0), Packets In Error : 0.00% (0 on 0), Packets Out Discard : 0.00% (0 on 0), Packets Out Error : 0.00% (0 on 0), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB, In Ucast : 0.00% (0 on 0), In Bcast : 0.00% (0 on 0), In Mcast : 0.00% (0 on 0), Out Ucast : 0.00% (0 on 0), Out Bcast : 0.00% (0 on 0), Out Mcast : 0.00% (0 on 0) | 'lte1~863359044096580#interface.traffic.in.bitspersecond'=0.00;;;0; 'lte1~863359044096580#interface.traffic.out.bitspersecond'=0.00;;;0; 'lte1~863359044096580#interface.packets.in.discard.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.error.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.discard.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.error.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0; 'lte1~863359044096580#interface.packets.in.unicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.broadcast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.in.multicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.unicast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.broadcast.percentage'=0.00%;;;0;100 'lte1~863359044096580#interface.packets.out.multicast.percentage'=0.00%;;;0;100
            ...      8      --check-metrics='\\\%{opstatus} eq "up"'                      OK: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      9      --warning-status='\\\%{admstatus} eq "up"'                    WARNING: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up) | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      10      --critical-status='\\\%{admstatus} eq "up"'                  CRITICAL: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up) | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      11     --warning-rsrq='-10' --critical-rsrq='0'                      CRITICAL: Interface 'lte1' [imei: 863359044096580] rsrq: -13 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;0:-10;0:0;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;
            ...      12     --warning-sinr='-1' --critical-sinr='10'                      WARNING: Interface 'lte1' [imei: 863359044096580] sinr: 0 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;0:-1;0:10;0;
            ...      13     --units-traffic                                               OK: Interface 'lte1' [imei: 863359044096580] Status : up (admin: up), rsrp: -94 dBm, rsrq: -13 dB, rssi: -65 dBm, sinr: 0 dB | 'lte1~863359044096580#interface.signal.rsrp.dbm'=-94;;;0; 'lte1~863359044096580#interface.signal.rsrq.db'=-13;;;0; 'lte1~863359044096580#interface.signal.rssi.dbm'=-65;;;0; 'lte1~863359044096580#interface.signal.sinr.dbm'=0;;;0;